using PkmnLib.Plugin.Gen7.Scripts.Pokemon;

namespace PkmnLib.Plugin.Gen7.Scripts.Moves;

[Script(ScriptCategory.Move, "bounce")]
public class Bounce : Script, IScriptPreventMove, IScriptOnBeforeMove, IScriptOnSecondaryEffect
{
    /// <inheritdoc />
    public void PreventMove(IExecutingMove move, ref bool prevent)
    {
        if (move.User.Volatile.Contains<ChargeBounceEffect>())
            return;

        move.User.Volatile.Add(new ChargeBounceEffect(move.User));
        move.MoveChoice.SetAdditionalData("bounce_charge", true);
        move.User.BattleData?.Battle.EventHook.Invoke(new DialogEvent("bounce_charge", new Dictionary<string, object>
        {
            { "user", move.User },
        }));
        prevent = true;
    }

    /// <inheritdoc />
    public void OnBeforeMove(IExecutingMove move)
    {
        move.User.Volatile.Remove(ScriptUtils.ResolveName<ChargeBounceEffect>());
    }

    /// <inheritdoc />
    public void OnSecondaryEffect(IExecutingMove move, IPokemon target, byte hit)
    {
        var battle = move.User.BattleData?.Battle;
        if (battle == null)
            return;
        var random = battle.Random;
        if (random.EffectChance(30, move, target, hit))
        {
            target.SetStatus("paralyzed", move.User);
        }
    }
}